$(function () {

    // jQuery
    var $document = $(document);
    var $box2d = $("#box2d");
    var $threeJs = $("#threeJs");
    // 萔
    //var IS_DEBUG_MODE = true;
    var IS_DEBUG_MODE = false;
    var FPS = 30;
    var SCALE = 100; // 1[^[LoX1pixɐݒ
    var STAGE_WIDTH = 800;
    var STAGE_HEIGHT = 600;
    var MAP = [
        [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
        [1, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 1],
        [1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1],
        [1, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 3, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 2, 2, 2, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 2, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 2, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 2, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 3, 0, 0, 0, 3, 2, 0, 0, 0, 0, 1],
        [1, 0, 2, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 0, 1],
        [1, 2, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 3, 0, 3, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 3, 0, 0, 0, 3, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 3, 0, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 3, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 2, 2, 0, 0, 0, 2, 2, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 2, 0, 2, 2, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 2, 0, 2, 0, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
        [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1],
        [1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 1],
        [1, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0, 1],
        [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
    ];
    var MAP_BLOCK_SIZE = 10;
    var MAP_WIDTH = MAP_BLOCK_SIZE * MAP[0].length;
    var MAP_HEIGHT = MAP_BLOCK_SIZE * MAP.length;
    var MAP_CENTER_X = MAP_BLOCK_SIZE * MAP[0].length / 2;
    var MAP_CENTER_Z = MAP_BLOCK_SIZE * MAP.length / 2;
    var DINAMIC_BLOCK_SIZE = 2;
    var KEYCODE_UP = 38;
    var KEYCODE_DOWN = 40;
    var KEYCODE_LEFT = 37;
    var KEYCODE_RIGHT = 39;
    var KEYCODE_SPACE = 32;
    var KEYCODE_SHIFT = 16;
    var MAX_STEER_ANGLE = Math.PI / 8; // ^C̍őpx
    var TOP_ENGINE_SPEED = 0.0015; // ō
    var CAR_LINEAR_DAMPING = 4; // قǒx̌Ȃ
    var CAR_ANGULAR_DAMPING = 10; // قǊpx̌Ȃ
    var CAMERA_ANGLE_TOP = "camera_angle_top"; // JAOiԂ̏ォj
    var CAMERA_ANGLE_BACK = "camera_angle_back"; // JAOiԂ̌j
    var CAMERA_ANGLE_INSIDE = "camera_angle_inside"; // JAOi^]ȁj
    var CAMERA_ANGLE_DEFAULT = CAMERA_ANGLE_TOP;
    // ϐ
    var box2dContext = null;
    var box2dWorld = null;
    var box2dObstacles = null;
    var box2dCar = null;
    var threeJsScene = null;
    var threeJsBackground = null;
    var threeJsCource = null;
    var threeJsBoxes = [];
    var threeJsCar = null;
    var threeJsLight = null;
    var threeJsCamera = null;
    var threeJsRenderer = null;
    var threeJsAxis = null;
    var threeJsControls = null;

    /* ---------- ANV ---------- */

    // 2DReLXg
    box2dContext = $box2d.get(0).getContext("2d");
    // 2DE
    box2dWorld = new Box2D.Dynamics.b2World(new Box2D.Common.Math.b2Vec2(0, 0), true);
    // 2DQ
    box2dObstacles = Box2dObstacles({
        world: box2dWorld,
        context: box2dContext
    });
    // 2D
    box2dCar = Box2dCar({
        world: box2dWorld,
        context: box2dContext,
        x: 270,
        y: 80
    });
    // 3DV[
    threeJsScene = new ThreeJsScene();
    // 3Dwi
    threeJsBackground = new ThreeJsBackground({scene: threeJsScene.getScene()});
    // 3DR[X
    threeJsCource = new ThreeJsCource({scene: threeJsScene.getScene()});
    // 3D
    var i = 0, max;
    for (i = 0, max = MAP.length; i < max; i = i + 1) {
        for (j = 0, max2 = MAP[i].length; j < max2; j = j + 1) {
            if (MAP[i][j] == 3) {
                var threeJsBox = new ThreeJsBoxes({
                    scene: threeJsScene.getScene(),
                    x: MAP_BLOCK_SIZE * j + (MAP_BLOCK_SIZE / 2),
                    y: DINAMIC_BLOCK_SIZE / 2,
                    z: MAP_BLOCK_SIZE * i + (MAP_BLOCK_SIZE / 2)
                });
                threeJsBoxes.push(threeJsBox);
            }
        }
    }
    // 3D
    threeJsCar = new ThreeJsCar({scene: threeJsScene.getScene()});
    // 3D
    threeJsLight = new ThreeJsLight({
        scene: threeJsScene.getScene(),
        target: threeJsCar.getGroup()
    });
    // 3DJ
    threeJsCamera = new ThreeJsCamera();
    // 3D_O
    threeJsRenderer = new ThreeJsRenderer({$target: $threeJs});
    // fobO[h
    if (IS_DEBUG_MODE) {
        threeJsAxis = new THREE.AxisHelper(1000);
        threeJsAxis.position.set(0, 0, 0);
        threeJsScene.add(threeJsAxis);
        threeJsControls = new THREE.OrbitControls(threeJsCamera.getCamera(), threeJsRenderer.getDomElement());
    }

    /* ---------- Cxg ---------- */

    $document.keydown(function (e) {
        if (e.keyCode == KEYCODE_UP) {
            box2dCar.setGear(1);
            box2dCar.startEngine();
        }
        if (e.keyCode == KEYCODE_DOWN) {
            box2dCar.setGear(-0.3);
            box2dCar.startEngine();
        }
        if (e.keyCode == KEYCODE_LEFT) {
            box2dCar.setSteeringAngle(-1 * MAX_STEER_ANGLE);
            box2dCar.setSteerSpeed(1);
        }
        if (e.keyCode == KEYCODE_RIGHT) {
            box2dCar.setSteeringAngle(MAX_STEER_ANGLE);
            box2dCar.setSteerSpeed(1);
        }
        if (e.keyCode == KEYCODE_SPACE) {
            threeJsCamera.changeMode();
        }
        if (e.keyCode == KEYCODE_SHIFT) {
            threeJsCamera.changeMode();
        }
    });

    $document.keyup(function (e) {
        if (e.keyCode == KEYCODE_LEFT || e.keyCode == KEYCODE_RIGHT) {
            box2dCar.setSteeringAngle(0);
            box2dCar.setSteerSpeed(8);
        }
        if (e.keyCode == KEYCODE_UP || e.keyCode == KEYCODE_DOWN) {
            box2dCar.stopEngine();
        }
    });

    setInterval(function () {
        // Box2D_O
        box2dCar.upDate();
        box2dWorld.Step(1 / FPS, 8, 3);
        box2dWorld.ClearForces();
        box2dWorld.DrawDebugData();
        // Box2D̎Ԃ̈ʒu擾ThreeJS̎ԏɕϊ
        var tagX = box2dCar.getPosition().x * SCALE;
        var tagZ = box2dCar.getPosition().y * SCALE;
        var tagAngle = -box2dCar.getAngle();
        var steeingAngle = box2dCar.getSteeringAngle() + getAngleByRotation(90);
        // ThreeJS_O
        threeJsCar.upDate({
            x: tagX,
            z: tagZ,
            angle: tagAngle,
            steeringAngle: steeingAngle
        });
        threeJsCamera.upDate({
            x: tagX,
            z: tagZ,
            angle: tagAngle
        });
        var i = 0, max;
        for (i = 0, max = threeJsBoxes.length; i < max; i = i + 1) {
            threeJsBoxes[i].upDate({
                x: box2dObstacles.getBoxPosition(i).x * SCALE,
                z: box2dObstacles.getBoxPosition(i).y * SCALE,
                angle: -box2dObstacles.getBoxAngle(i)
            });
        }
        threeJsRenderer.upDate({
            scene: threeJsScene.getScene(),
            camera: threeJsCamera.getCamera()
        });
        if (threeJsControls) threeJsControls.update();
    }, 1000 / FPS);

    /* ---------- ʊ֐ ---------- */

    function getAngleByRotation(rot) {
        return rot * Math.PI / 180;
    }

    /* ---------- ThreeJSW[ ---------- */

    /**
     * ThreeJSV[
     * @returns {{getScene: Function, add: Function}}
     * @constructor
     */
    function ThreeJsScene() {

        var _scene = null;

        // RXgN^
        function _constructor() {
            _scene = new THREE.Scene();
        }

        _constructor();

        return {
            getScene: getScene,
            add: add
        };

        // ---------- pubN\bh ---------- //

        function getScene() {
            return _scene;
        }

        function add(item) {
            _scene.add(item);
        }

    }

    /**
     * ThreeJSwi
     * @param params
     * @returns {{}}
     * @constructor
     */
    function ThreeJsBackground(params) {

        var _scene = params["scene"];
        var _meshField = null;
        var _meshSky = null;

        // RXgN^
        function _constructor() {
            var geometry = null;
            var texture = null;
            var material = null;
            // n
            geometry = new THREE.PlaneGeometry(MAP_WIDTH * 2, MAP_HEIGHT * 2);
            texture = new THREE.ImageUtils.loadTexture("field.jpg");
            material = new THREE.MeshBasicMaterial({map: texture, side: THREE.DoubleSide, bumpScale: 0.1});
            _meshField = new THREE.Mesh(geometry, material);
            _meshField.position.set(MAP_CENTER_X, 0, MAP_CENTER_Z);
            _meshField.rotation.x = getAngleByRotation(90);
            _scene.add(_meshField);
            // 
            geometry = new THREE.CylinderGeometry(MAP_WIDTH * 10, MAP_HEIGHT * 10, 2500, 8, 1, true);
            texture = new THREE.ImageUtils.loadTexture("sky.jpg");
            material = new THREE.MeshBasicMaterial({map: texture, side: THREE.BackSide});
            _meshSky = new THREE.Mesh(geometry, material);
            _meshSky.position.set(MAP_CENTER_X, 300 / 2, MAP_CENTER_Z);
            _scene.add(_meshSky);
        }

        _constructor();

        return {};

    }

    /**
     * ThreeJSR[X
     * @param params
     * @returns {{}}
     * @constructor
     */
    function ThreeJsCource(params) {

        var _scene = params["scene"];

        // RXgN^
        function _constructor() {
            var geometry = null;
            var texture = null;
            var material = null;
            var mesh = null;
            // R[X
            geometry = new THREE.PlaneGeometry(MAP_WIDTH, MAP_HEIGHT);
            texture = new THREE.ImageUtils.loadTexture("course.jpg");
            material = new THREE.MeshPhongMaterial({map: texture, side: THREE.DoubleSide, bumpMap: texture, bumpScale: 0.1, specular: 0xFFFFFF, shininess: 2000});
            mesh = new THREE.Mesh(geometry, material);
            mesh.position.set(MAP_CENTER_X, 0.1, MAP_CENTER_Z);
            mesh.rotation.x = getAngleByRotation(90);
            mesh.receiveShadow = true;
            _scene.add(mesh);
            // ǁij
            geometry = new THREE.Geometry();
            texture = new THREE.ImageUtils.loadTexture("block2.jpg");
            material = new THREE.MeshPhongMaterial({map: texture, bumpMap: texture, bumpScale: 0.1, specular: 0xFFFFFF, shininess: 1000});
            for (i = 0, max = MAP.length; i < max; i = i + 1) {
                for (j = 0, max2 = MAP[i].length; j < max2; j = j + 1) {
                    if (MAP[i][j] == 1) {
                        mesh = new THREE.Mesh(new THREE.CubeGeometry(MAP_BLOCK_SIZE, MAP_BLOCK_SIZE, MAP_BLOCK_SIZE), new THREE.MeshBasicMaterial());
                        mesh.position.set(MAP_BLOCK_SIZE * j + (MAP_BLOCK_SIZE / 2), MAP_BLOCK_SIZE / 2, MAP_BLOCK_SIZE * i + (MAP_BLOCK_SIZE / 2));
                        THREE.GeometryUtils.merge(geometry, mesh);
                    }
                }
            }
            mesh = new THREE.Mesh(geometry, material);
            mesh.castShadow = true;
            _scene.add(mesh);
            // ǁij
            geometry = new THREE.Geometry();
            texture = new THREE.ImageUtils.loadTexture("block.jpg");
            material = new THREE.MeshPhongMaterial({map: texture, bumpMap: texture, bumpScale: 0.1, specular: 0xFFFFFF, shininess: 1000});
            for (i = 0, max = MAP.length; i < max; i = i + 1) {
                for (j = 0, max2 = MAP[i].length; j < max2; j = j + 1) {
                    if (MAP[i][j] == 2) {
                        mesh = new THREE.Mesh(new THREE.CubeGeometry(MAP_BLOCK_SIZE, MAP_BLOCK_SIZE, MAP_BLOCK_SIZE), new THREE.MeshBasicMaterial());
                        mesh.position.set(MAP_BLOCK_SIZE * j + (MAP_BLOCK_SIZE / 2), -MAP_BLOCK_SIZE / 4, MAP_BLOCK_SIZE * i + (MAP_BLOCK_SIZE / 2));
                        THREE.GeometryUtils.merge(geometry, mesh);
                    }
                }
            }
            mesh = new THREE.Mesh(geometry, material);
            mesh.castShadow = true;
            _scene.add(mesh);
        }

        _constructor();

        return {};

    }

    /**
     * ThreeJS
     * @param params
     * @returns {{upDate: Function}}
     * @constructor
     */
    function ThreeJsBoxes(params) {

        var _scene = params["scene"];
        var _x = params["x"];
        var _y = params["y"];
        var _z = params["z"];
        var _mesh = null;

        // RXgN^
        function _constructor() {
            var geometry = new THREE.CubeGeometry(DINAMIC_BLOCK_SIZE, DINAMIC_BLOCK_SIZE, DINAMIC_BLOCK_SIZE);
            var texture = new THREE.ImageUtils.loadTexture("box.jpg");
            var material = new THREE.MeshPhongMaterial({map: texture, bumpMap: texture, bumpScale: 0.1, specular: 0xFFFFFF, shininess: 1000});
            _mesh = new THREE.Mesh(geometry, material);
            _mesh.position.set(_x, _y, _z);
            _mesh.castShadow = true;
            _scene.add(_mesh);
        }

        _constructor();

        return {
            upDate: upDate
        };

        // ---------- pubN\bh ---------- //

        function upDate(params) {
            var x = params["x"];
            var z = params["z"];
            var angle = params["angle"];
            //
            _mesh.position.x = x;
            _mesh.position.z = z;
            _mesh.rotation.y = angle;
        }

    }

    /**
     * ThreeJS
     * @param params
     * @returns {{getGroup: Function, upDate: Function}}
     * @constructor
     */
    function ThreeJsCar(params) {

        var _scene = params["scene"];
        var _group = null;
        var _meshBody = null;
        var _meshBody2 = null;
        var _meshWheelFrontLeft = null;
        var _meshWheelFrontRight = null;
        var _meshWheelBackLeft = null;
        var _meshWheelBackRight = null;

        // RXgN^
        function _constructor() {
            var geometry = null;
            var texture = null;
            var material = null;
            // 
            _group = new THREE.Object3D();
            _group.position.set(0, 0.5, 0);
            _scene.add(_group);
            // ԁi{fBj
            geometry = new THREE.CubeGeometry(2, 1, 5);
            material = new THREE.MeshPhongMaterial({color: 0xFF0000, ambient: 0xFF0000, metal: true, specular: 0xFFFFFF, shininess: 100});
            _meshBody = new THREE.Mesh(geometry, material);
            _meshBody.castShadow = true;
            _meshBody.position.set(0, 0.5, 0);
            _group.add(_meshBody);
            //
            geometry = new THREE.CubeGeometry(2, 0.5, 3);
            _meshBody2 = new THREE.Mesh(geometry, material);
            _meshBody2.castShadow = true;
            _meshBody2.position.set(0, 1.25, -0.5);
            _group.add(_meshBody2);
            // ԁi^Cj
            geometry = new THREE.CylinderGeometry(0.5, 0.5, 0.5);
            material = new THREE.MeshPhongMaterial({color: 0x000000, ambient: 0x333333});
            _meshWheelFrontLeft = new THREE.Mesh(geometry, material);
            _meshWheelFrontLeft.rotation.x = getAngleByRotation(90);
            _meshWheelFrontLeft.rotation.z = getAngleByRotation(90);
            _meshWheelFrontLeft.position.set(1.1, 0.25, 1.5);
            _group.add(_meshWheelFrontLeft);
            //
            geometry = new THREE.CylinderGeometry(0.5, 0.5, 0.5);
            _meshWheelFrontRight = new THREE.Mesh(geometry, material);
            _meshWheelFrontRight.rotation.x = getAngleByRotation(90);
            _meshWheelFrontRight.rotation.z = getAngleByRotation(90);
            _meshWheelFrontRight.position.set(-1.1, 0.25, 1.5);
            _group.add(_meshWheelFrontRight);
            //
            geometry = new THREE.CylinderGeometry(0.5, 0.5, 0.5);
            _meshWheelBackLeft = new THREE.Mesh(geometry, material);
            _meshWheelBackLeft.rotation.x = getAngleByRotation(90);
            _meshWheelBackLeft.rotation.z = getAngleByRotation(90);
            _meshWheelBackLeft.position.set(1.1, 0.25, -1.5);
            _group.add(_meshWheelBackLeft);
            //
            geometry = new THREE.CylinderGeometry(0.5, 0.5, 0.5);
            _meshWheelBackRight = new THREE.Mesh(geometry, material);
            _meshWheelBackRight.rotation.x = getAngleByRotation(90);
            _meshWheelBackRight.rotation.z = getAngleByRotation(90);
            _meshWheelBackRight.position.set(-1.1, 0.25, -1.5);
            _group.add(_meshWheelBackRight);
        }

        _constructor();

        return {
            getGroup: getGroup,
            upDate: upDate
        };

        // ---------- pubN\bh ---------- //

        function getGroup() {
            return _group;
        }

        function upDate(params) {
            var x = params["x"];
            var z = params["z"];
            var angle = params["angle"];
            var steeringAngle = params["steeringAngle"];
            //
            _group.position.x = x;
            _group.position.z = z;
            _group.rotation.y = angle;
            _meshWheelFrontLeft.rotation.z = steeringAngle;
            _meshWheelFrontRight.rotation.z = steeringAngle;
        }

    }

    /**
     * ThreeJSCg
     * @param params
     * @returns {{}}
     * @constructor
     */
    function ThreeJsLight(params) {

        var _scene = params["scene"];
        var _target = params["target"];
        var _spot = null;
        var _ambient = null;

        // RXgN^
        function _constructor() {
            // X|bgCg
            _spot = new THREE.SpotLight(0xFFFFFF, 1, 1000, Math.PI / 1, 20);
            _spot.position.set(MAP_CENTER_X, 200, MAP_CENTER_Z);
            _spot.castShadow = true;
            _spot.target = _target;
            if (IS_DEBUG_MODE) _spot.shadowCameraVisible = true;
            _scene.add(_spot);
            // 
            _ambient = new THREE.AmbientLight(0x888888);
            _scene.add(_ambient);
        }

        _constructor();

        return {};

    }

    /**
     * ThreeJSJ
     * @returns {{getCamera: Function, changeMode: Function, upDate: Function}}
     * @constructor
     */
    function ThreeJsCamera() {

        var _camera = null;
        var _mode = CAMERA_ANGLE_DEFAULT;

        // RXgN^
        function _constructor() {
            // J
            _camera = new THREE.PerspectiveCamera(45, STAGE_WIDTH / STAGE_HEIGHT, 1, 10000);
            _camera.position.x = MAP_CENTER_X;
            _camera.position.y = 200;
            _camera.position.z = MAP_CENTER_Z;
            _camera.lookAt({x: 0, y: 0, z: 0});
        }

        _constructor();

        return {
            getCamera: getCamera,
            changeMode: changeMode,
            upDate: upDate
        };

        // ---------- pubN\bh ---------- //

        function getCamera() {
            return _camera;
        }

        function changeMode() {
            switch (_mode) {
                case CAMERA_ANGLE_TOP:
                    _mode = CAMERA_ANGLE_BACK;
                    break;
                case CAMERA_ANGLE_BACK:
                    _mode = CAMERA_ANGLE_INSIDE;
                    break;
                case CAMERA_ANGLE_INSIDE:
                    _mode = CAMERA_ANGLE_TOP;
                    break;
            }
        }

        function upDate(params) {
            if (IS_DEBUG_MODE) return;
            //
            var x = params["x"];
            var z = params["z"];
            var angle = params["angle"];
            //
            if (_mode == CAMERA_ANGLE_TOP) {
                _camera.position.x = x + (20 * Math.sin(angle));
                _camera.position.y = 80;
                _camera.position.z = z + (20 * Math.cos(angle));
                _camera.rotation.x = getAngleByRotation(-90);
                _camera.rotation.y = 0;
                _camera.rotation.z = angle - getAngleByRotation(180);
            } else if (_mode == CAMERA_ANGLE_BACK) {
                _camera.position.x = x - (27 * Math.sin(angle));
                _camera.position.y = 10;
                _camera.position.z = z - (27 * Math.cos(angle));
                _camera.rotation.y = angle - getAngleByRotation(180);
                _camera.rotation.x = 0;
                _camera.rotation.z = 0;
            } else if (_mode == CAMERA_ANGLE_INSIDE) {
                _camera.position.x = x;
                _camera.position.y = 4;
                _camera.position.z = z;
                _camera.rotation.y = angle - getAngleByRotation(180);
                _camera.rotation.x = 0;
                _camera.rotation.z = 0;
            }
        }

    }

    /**
     * ThreeJS_?
     * @param params
     * @returns {{getDomElement: Function, upDate: Function}}
     * @constructor
     */
    function ThreeJsRenderer(params) {

        var _$target = params["$target"];
        var _renderer = null;
        var _domElement = null;

        // RXgN^
        function _constructor() {
            _renderer = new THREE.WebGLRenderer({antialias: true});
            _renderer.setSize(STAGE_WIDTH, STAGE_HEIGHT);
            _renderer.setClearColor(0x000000, 1);
            _renderer.shadowMapEnabled = true;
            _domElement = _renderer.domElement;
            _$target.append(_domElement);
        }

        _constructor();

        return {
            getDomElement: getDomElement,
            upDate: upDate
        };

        // ---------- pubN\bh ---------- //

        function getDomElement() {
            return _domElement;
        }

        function upDate(params) {
            var scene = params["scene"];
            var camera = params["camera"];
            _renderer.render(scene, camera);
        }

    }

    /* ---------- Box2dW[ ---------- */

    /**
     * Q
     * @param params
     * @returns {{getBoxPosition: Function, getBoxAngle: Function}}
     * @constructor
     */
    function Box2dObstacles(params) {

        var _world = params["world"];
        var _context = params["context"];
        var _boxes = [];

        // RXgN^
        function _constructor() {
            var debugDraw = new Box2D.Dynamics.b2DebugDraw();
            debugDraw.SetSprite(_context);
            debugDraw.SetDrawScale(SCALE);
            debugDraw.SetFillAlpha(0.5);
            debugDraw.SetLineThickness(1.0);
            debugDraw.SetFlags(Box2D.Dynamics.b2DebugDraw.e_shapeBit | Box2D.Dynamics.b2DebugDraw.e_jointBit);
            _world.SetDebugDraw(debugDraw);
            // MAPɉĕǂݒ
            var i = 0, max;
            for (i = 0, max = MAP.length; i < max; i = i + 1) {
                var j = 0, max2;
                for (j = 0, max2 = MAP[i].length; j < max2; j = j + 1) {
                    if (MAP[i][j] == 1 || MAP[i][j] == 2) {
                        Box2dBox({
                            world: _world,
                            context: _context,
                            x: MAP_BLOCK_SIZE * j + (MAP_BLOCK_SIZE / 2),
                            y: MAP_BLOCK_SIZE * i + (MAP_BLOCK_SIZE / 2),
                            width: MAP_BLOCK_SIZE,
                            height: MAP_BLOCK_SIZE,
                            options: {
                                type: Box2D.Dynamics.b2Body.b2_staticBody,
                                restitution: 0.5
                            }
                        });
                    }
                    if (MAP[i][j] == 3) {
                        var box = Box2dBox({
                            world: _world,
                            context: _context,
                            x: MAP_BLOCK_SIZE * j + (MAP_BLOCK_SIZE / 2),
                            y: MAP_BLOCK_SIZE * i + (MAP_BLOCK_SIZE / 2),
                            width: DINAMIC_BLOCK_SIZE,
                            height: DINAMIC_BLOCK_SIZE,
                            options: {
                                restitution: 0.5,
                                linearDamping: 1,
                                angularDamping: 1,
                                density: 0.25 // 
                            }
                        });
                        _boxes.push(box.getBody());
                    }
                }
            }
        }

        _constructor();

        return {
            getBoxPosition: getBoxPosition,
            getBoxAngle: getBoxAngle
        };

        function getBoxPosition(index) {
            return _boxes[index].GetPosition();
        }

        function getBoxAngle(index) {
            return _boxes[index].GetAngle();
        }

    }

    /**
     * 
     * @param params
     * @returns {{setGear: Function, setSteeringAngle: Function, setSteerSpeed: Function, startEngine: Function, stopEngine: Function, getPosition: Function, getAngle: Function, getSteeringAngle: Function, upDate: Function}}
     * @constructor
     */
    function Box2dCar(params) {

        var _world = params["world"];
        var _context = params["context"];
        var _x = params["x"];
        var _y = params["y"];
        //
        var _isOnEngine = false;
        var _engineSpeed = 0;
        var _gear = 1;
        var _body = null;
        var _frontLeftWheel = null;
        var _frontRightWheel = null;
        var _rearLeftWheel = null;
        var _rearRightWheel = null;
        var _steeringAngle = 0;
        var _steerSpeed = 1;
        var _frontWheels = [];
        var _rearWheels = [];
        var _frontWheelJoints = [];
        // RXgN^
        function _constructor() {
            // ԑ
            var carWidth = 2;
            var carHeight = 5;
            var wheelWidth = 0.5;
            var wheelHeight = 1;
            _body = Box2dBox({
                world: _world,
                x: _x,
                y: _y,
                width: carWidth,
                height: carHeight,
                options: {
                    linearDamping: CAR_LINEAR_DAMPING,
                    angularDamping: CAR_ANGULAR_DAMPING
                }
            }).getBody();
            // tgzC[
            _frontLeftWheel = Box2dBox({
                world: _world,
                context: _context,
                x: _x - carWidth / 2,
                y: _y + carHeight / 4,
                width: wheelWidth,
                height: wheelHeight,
                options: {}
            }).getBody();
            _frontRightWheel = Box2dBox({
                world: _world,
                context: _context,
                x: _x + carWidth / 2,
                y: _y + carHeight / 4,
                width: wheelWidth,
                height: wheelHeight,
                options: {}
            }).getBody();
            _frontWheels.push(_frontLeftWheel);
            _frontWheels.push(_frontRightWheel);
            // AzC[
            _rearLeftWheel = Box2dBox({
                world: _world,
                context: _context,
                x: _x - carWidth / 2,
                y: _y - carHeight / 3,
                width: wheelWidth,
                height: wheelHeight,
                options: {}
            }).getBody();
            _rearRightWheel = Box2dBox({
                world: _world,
                context: _context,
                x: _x + carWidth / 2,
                y: _y - carHeight / 3,
                width: wheelWidth,
                height: wheelHeight,
                options: {}
            }).getBody();
            _rearWheels.push(_rearLeftWheel);
            _rearWheels.push(_rearRightWheel);
            // tgzC[WCg
            var wheel = null;
            var jointDef = null;
            var i = 0, max;
            for (i = 0, max = _frontWheels.length; i < max; i = i + 1) {
                wheel = _frontWheels[i];
                jointDef = new Box2D.Dynamics.Joints.b2RevoluteJointDef();
                jointDef.Initialize(_body, wheel, wheel.GetWorldCenter()); // Ȃ2̂̕ƁCȂʒuiOւ̒jgāC`
                jointDef.enableMotor = true; // ԗւ񂷂悤ɂ
                jointDef.maxMotorTorque = 100000; // gN̐ݒi傫قǍ⓹ɋȂj
                jointDef.enableLimit = true; // ͈͐ݒ
                jointDef.lowerAngle = -1 * MAX_STEER_ANGLE; // ͈͉(m)
                jointDef.upperAngle = MAX_STEER_ANGLE; // ͈͏(m)
                _frontWheelJoints.push(_world.CreateJoint(jointDef));
            }
            // AzC[WCg
            for (i = 0, max = _rearWheels.length; i < max; i = i + 1) {
                wheel = _rearWheels[i];
                jointDef = new Box2D.Dynamics.Joints.b2PrismaticJointDef();
                jointDef.Initialize(_body, wheel, wheel.GetWorldCenter(), new Box2D.Common.Math.b2Vec2(1, 0));
                jointDef.enableLimit = true; // ͈͐ݒ
                jointDef.lowerTranslation = 0; // ͈͉(m)
                jointDef.upperTranslation = 0; // ͈͏(m)
                _world.CreateJoint(jointDef);
            }
        }

        _constructor();

        return {
            setGear: setGear,
            setSteeringAngle: setSteeringAngle,
            setSteerSpeed: setSteerSpeed,
            startEngine: startEngine,
            stopEngine: stopEngine,
            getPosition: getPosition,
            getAngle: getAngle,
            getSteeringAngle: getSteeringAngle,
            upDate: upDate
        };

        function setGear(value) {
            _gear = value;
        }

        function setSteeringAngle(value) {
            _steeringAngle = value;
        }

        function setSteerSpeed(value) {
            _steerSpeed = value;
        }

        function startEngine() {
            _isOnEngine = true;
            _engineSpeed = _gear * TOP_ENGINE_SPEED;
        }

        function stopEngine() {
            _isOnEngine = false;
            _engineSpeed = 0;
        }

        function getPosition() {
            return _body.GetPosition();
        }

        function getAngle() {
            return _body.GetAngle();
        }

        function getSteeringAngle() {
            return _frontWheelJoints[0].GetJointAngle();
        }

        function upDate() {
            // 
            var i = 0, max;
            for (i = 0, max = _frontWheels.length; i < max; i = i + 1) {
                var wheel = _frontWheels[i];
                var direction = wheel.GetTransform().R.col2.Copy();
                direction.Multiply(_engineSpeed);
                wheel.ApplyForce(direction, wheel.GetPosition());
            }
            // px
            for (i = 0, max = _frontWheelJoints.length; i < max; i = i + 1) {
                var wheelJoint = _frontWheelJoints[i];
                var angleDiff = _steeringAngle - wheelJoint.GetJointAngle();
                wheelJoint.SetMotorSpeed(angleDiff * _steerSpeed);
            }
        }

    }

    /**
     * BOX
     * @param params
     * @returns {{getBody: Function}}
     * @constructor
     */
    function Box2dBox(params) {

        var _world = params["world"];
        var _context = params["context"];
        var _x = params["x"];
        var _y = params["y"];
        var _width = params["width"];
        var _height = params["height"];
        var _options = params["options"];
        //
        var _body = null;
        var _bodyDef = null;
        var _fixtureDef = null;
        // RXgN^
        function _constructor() {
            _options = $.extend(true, {
                density: 1,
                friction: 0,
                restitution: 0.2,
                linearDamping: 0,
                angularDamping: 0,
                gravityScale: 1,
                type: Box2D.Dynamics.b2Body.b2_dynamicBody
            }, _options);
            //
            _fixtureDef = new Box2D.Dynamics.b2FixtureDef;
            _fixtureDef.density = _options.density;
            _fixtureDef.friction = _options.friction;
            _fixtureDef.restitution = _options.restitution;
            _fixtureDef.shape = new Box2D.Collision.Shapes.b2PolygonShape();
            _fixtureDef.shape.SetAsBox(_width / 2 / SCALE, _height / 2 / SCALE);
            //
            _bodyDef = new Box2D.Dynamics.b2BodyDef();
            _bodyDef.position.Set(_x / SCALE, _y / SCALE);
            _bodyDef.linearDamping = _options.linearDamping;
            _bodyDef.angularDamping = _options.angularDamping;
            _bodyDef.type = _options.type;
            //
            _body = _world.CreateBody(_bodyDef);
            _body.CreateFixture(_fixtureDef);
        }

        _constructor();

        return {
            getBody: getBody
        };

        function getBody() {
            return _body;
        }

    }

});